import Vue from 'vue';
import Component from "vue-class-component";

@Component({
    template:'<li v-on:click="onClick">{{name}}</li>',
    props:{
        name:String
    }
})
class MyData extends Vue{
    onClick = ():void =>{
        console.log(this.$props.name);
    }
}

@Component({
    template:'<p>{{name}}</p>',
    props:{
        name:String
    }
})
class MyParagraph extends Vue{}

@Component({
    template:'<div><h1>{{title}}</h1>' +
        '<my-paragraph v-bind:name="myValue"></my-paragraph>' +
        '<p>{{countList}} items here.</p>' +
        '<ul>' +
        '<my-data v-for="item in list" v-bind:name="item.name" v-bind:key="item.name"></my-data>\n' +
        '</ul></div>',
    components: {
        'my-data':MyData,
        'my-paragraph':MyParagraph
    }
})
export class App extends Vue{
    title:string;
    list:Array<MyData>;
    data(){
        return{
            title:'Hello Vue.js',
            list:[
                {name:'item A'},
                {name:'item B'}
            ],
            myValue:'This vue sample is implemented with Typescript.'
        };
    }
    get countList():Number{
        return this.list.length;
    }
}

const app = new App({
    el:'#app'
});
window.app = app;