const CopyWebpackPlugin = require("copy-webpack-plugin");

const copyWebpack = new CopyWebpackPlugin({
    patterns:[
        {
            from: "./**/*.{html,css}",
            to: "./",
            context: "./src",
        }
    ],
})

module.exports = {
    mode: "development",
    entry: {"main":"./src/main.ts"},
    output: {
        path: `${__dirname}/dist`,
        filename: "[name].js"
    },
    module: {
        rules: [
            {
                // if file extension is .ts
                test: /\.ts$/,
                // then compile with tsc
                use: "ts-loader"
            }
        ]
    },
    // resolve ts file in import statement
    resolve: {
        extensions: [".ts"],
        alias: {
            vue: "vue/dist/vue.js"
        }
    },
    // for ES5(IE11 etc...)
    target: ["web", "es5"],
    // copy static files
    plugins: [copyWebpack]
};